/*
	NCP-010 Controller Version 11/19/2010-A
	(C) 2010 Jason Hunt nulluser@gmail.com

	This program is free software; you can redistribute it and/or
    	modify it under the terms of the GNU General Public License
    	as published by the Free Software Foundation; either version 2
    	of the License, or (at your option) any later version.

    	This program is distributed in the hope that it will be useful,
    	but WITHOUT ANY WARRANTY; without even the implied warranty of
    	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    	GNU General Public License for more details.

    	You should have received a copy of the GNU General Public License
    	along with this program; if not, write to the Free Software
    	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	File: main.c
*/


#include "core.h"

_FOSC(CSW_FSCM_OFF & XT_PLL8);	
_FWDT(WDT_OFF);
_FBORPOR(PBOR_OFF & BORV_27 & PWRT_16 & MCLR_EN);
_FGS(CODE_PROT_OFF);




/* Do a short beep on the buzzer for debugging */
// Hard coded delay loops, can be used inside interrupts
void beep (void)
{
	unsigned int i, j;

	for (i = 0; i < 40; i++)
	{
		buzzer = ~buzzer;

		for (j = 0; j < 3000; j++);
	}

	buzzer = 0;
}
/* End of beep */


/* Setup the device */
void device_init ( void )
{
	// Set port directions
	TRISA = 0;
	TRISB = 0;
	TRISC = 0;
	TRISD = 0;
	
	TRISF = 0b00010100;

	_LATF0 = 0; 
	_LATF1 = 0; 
	_LATF6 = 0;
	_LATD0 = 0; 


	INTCON1bits.NSTDIS = 1;
}
/* End of device_init */


/* Main */
int main ( void )
{
	device_init();
	timer_init();
	serial_init();
	analog_init();
	controller_init ();

//	beep();

//	serial_str("\nStart\n");

	timer_delay(50);

	while (1)
	{
		if (msg_telemetry)
			controller_telemetry();

		if (msg_controller)
			controller_process();

	//	if (msg_debug)
	//		transfer_debug();

	//	if (msg_camera)
			camera_update();

//		timer_delay(10);


	}

	return(0);
}
/* End of main */


