/*
	NCP-010 Controller Version 11/19/2010-A
	(C) 2010 Jason Hunt nulluser@gmail.com

	This program is free software; you can redistribute it and/or
    	modify it under the terms of the GNU General Public License
    	as published by the Free Software Foundation; either version 2
    	of the License, or (at your option) any later version.

    	This program is distributed in the hope that it will be useful,
    	but WITHOUT ANY WARRANTY; without even the implied warranty of
    	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    	GNU General Public License for more details.

    	You should have received a copy of the GNU General Public License
    	along with this program; if not, write to the Free Software
    	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	File: timer.c
*/

#include "core.h"


unsigned int delay_count = 0;
unsigned int status_count = 0; 
unsigned char error_act = 0;


/* Delay in d is in seconds * 100 */
void timer_delay( unsigned int d )
{
	delay_count = 0;
	while(delay_count < d);
}
/* End of timer delay */



/* This will fire every 10 milliseconds */
void __attribute__((__interrupt__, auto_psv)) _T1Interrupt (void)
{
	IFS0bits.T1IF = 0;
	delay_count++;



	serial_check();
	controller_check();

	if (error_act)
	{
		if (++status_count > 10)
		{
			status_count = 0;
			led = ~led;
		//	U1TXREG = 'A';
		}
	}
	else
		led = 0;



	static unsigned int sec_count = 0;

	
	if (++sec_count > 100)
	{
		sample_rate = sample_count;
		sample_count = 0;
		sec_count=0;

	}

	if (camera_delay)
		camera_delay--;


}
/* End of  _T1Interrupt  */




/* Servo interrupt */
void __attribute__((__interrupt__, auto_psv)) _T2Interrupt (void)
{
	IFS0bits.T2IF = 0;
	update_servoes();
}
/* End of  _T2Interrupt */



/* Setup the timer */
void timer_init ( void )
{
	// Setup timer for 1ms and enble interrupt
	T1CON = 0x20;			// Set prescaler to TCY / 64 
	PR1 = FCY / 64 / TIMER1_FREQ;
	T1CONbits.TON = 1;		// Enable timer
	IEC0bits.T1IE = 1;		// Enable interrupt

	// Setup timer for 1ms and enble interrupt
//	T1CON = 0x20;			// Set prescaler to TCY / 8
	T2CONbits.TCKPS = 0b01; // 8 prescale
	PR2 = FCY / 64 / TIMER1_FREQ;
	T2CONbits.TON = 1;		// Enable timer
	IEC0bits.T2IE = 1;		// Enable interrupt


}
/* End of timer_init */



