/*
	Serial Camera Client 
	Version 11/24/2010-A
	(C) 2010 Jason Hunt nulluser@gmail.com

	This program is free software; you can redistribute it and/or
    	modify it under the terms of the GNU General Public License
    	as published by the Free Software Foundation; either version 2
    	of the License, or (at your option) any later version.

    	This program is distributed in the hope that it will be useful,
    	but WITHOUT ANY WARRANTY; without even the implied warranty of
    	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    	GNU General Public License for more details.

    	You should have received a copy of the GNU General Public License
    	along with this program; if not, write to the Free Software
    	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/


#ifndef SERIAL_H
#define SERIAL_H


   
#define HEADER_SIZE 2
#define FOOTER_SIZE 1

#define TIMEOUT        2000  

#define DEVICE_CONT         1

#define DEVICE_CAM1         8
#define DEVICE_CAM2         9
#define DEVICE_CAM3         10
#define DEVICE_CAM4         11

#define DEVICE_DEBUG        15


#define COMM_PACKET_WAIT    0 
#define COMM_PACKET_DATA    1
#define COMM_PACKET_FLUSH   2


#define COMM_RX_MAX         512


class serial_class 
{
  public:
    serial_class( void );
    ~serial_class( void );


    void start( unsigned int baud );
    void stop( void );
    
    void reset( void );
    void flush ( void );
    
    
    int send(unsigned char *buffer, unsigned int len);
    
    int transfer(unsigned char device_id,
                 unsigned char *send_buff, int send_bytes,  
                 unsigned char *recv_buff, int recv_bytes);
                        
    int send_packet(unsigned char device_id, 
                    unsigned char *send_buff, 
                    int send_bytes);                     



int serial_class :: validate_packet(unsigned char *buff, unsigned int len);

int serial_class :: process_packet( unsigned char *buff, unsigned int len );
int serial_class :: process_byte(unsigned char b);


/* preform a transfer with the controller */
int serial_class :: serial_transfer(unsigned char device_id,
                    unsigned char *send_buff, int send_bytes,  
                    unsigned char *recv_buff, int recv_bytes);


int serial_class :: serial_send(unsigned char *buff, unsigned int len);

int serial_class :: do_serial_packet(unsigned char device_id, 
                     unsigned char *send_buff, 
                     int send_bytes);
                     
int serial_class :: serial_packet(unsigned char device_id, 
                  unsigned char *send_buff, 
                  int send_bytes);                     
                  
                     
                        
       void        set_port(char *pn) { strcpy(serial_port, pn); };
                              
                                    
                     
                     
/* End of serial_transfer */



    int get_state( void );         
    
    void check( void );
    
    
    
    DWORD WINAPI serial_thread(void);

    static DWORD WINAPI thread_wrapper(LPVOID pvoid) ;
        


    OVERLAPPED ol_reader ,ol_writer ;
    

    HANDLE h_serial ;			      // Handle for serial port

    bool serial_ok;               // True if serial is working 

    bool timeout_flag ;            // Set once for a timeout condition

    char serial_port[10];                 // Filename of serial port

    bool enable_mux  ;
    bool serial_debug ;

    HANDLE serial_mutex;

   HANDLE serial_stop;                 // Event to stop serial threads
   HANDLE h_serial_thread;        // Handles for serial thread

    bool serial_running ;
    bool debug_serial;
    bool serial_hold ;


    double flush_time;
              
                    
     unsigned char buff[COMM_RX_MAX];
     unsigned char state ;
     unsigned int packet_size;        // Total size of packet, header and footer included
    unsigned int b_index;                 
                        
};


extern serial_class serial;


#endif



