/*
	Serial Camera Client 
	Version 11/24/2010-A
	(C) 2010 Jason Hunt nulluser@gmail.com

	This program is free software; you can redistribute it and/or
    	modify it under the terms of the GNU General Public License
    	as published by the Free Software Foundation; either version 2
    	of the License, or (at your option) any later version.

    	This program is distributed in the hope that it will be useful,
    	but WITHOUT ANY WARRANTY; without even the implied warranty of
    	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    	GNU General Public License for more details.

    	You should have received a copy of the GNU General Public License
    	along with this program; if not, write to the Free Software
    	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifndef SERIAL_CAMERA_H
#define SERIAL_CAMERA_H

class serial_cam_class
{
public:
    serial_cam_class( char * name_, unsigned char id, unsigned int format );

    ~serial_cam_class();


    void camera_setup_image(int image_size);

    void start( void);
    void stop ( void );

//    int runProcess (void* pThis);

    void paint( void );


    static LRESULT CALLBACK cam_proc_wrapper(HWND hwnd, UINT message, WPARAM w, LPARAM l);
    
    
    LRESULT CALLBACK cam_proc(HWND hwnd, UINT message, WPARAM w, LPARAM l);

void serial_cam_class::camera_data( unsigned char *buff, int len);



    unsigned char device_id ;

    HANDLE h_camera_thread ;               // Handel for serial control thread
    DWORD camera_thread_id;               // Serial control 
    bool camera_running;          // True if serial thread is running
    
    CRITICAL_SECTION camera_thread_lock;  // Lock for serial thread
    
    int x_size;
    int y_size;


    int display_x;
    int display_y;

    int image_format;
    
    
    byte *compressed_buffer;            // Buffer for compressed data
    byte *transcode_buffer;             // Buffer for transcoding
    color_type *camera_buffer;          // Buffer for camera data

    BITMAPINFO camera_buffer_info;      // Bitmap info for camera

    HWND cam_window;
    int max_compressed;                 // Max compressed size

    int frames;


    HDC memdc;	           	           // Memory device context
    HBITMAP h_mem_bitmap;                // Offscreen bitmap
    int buff_index;
    
    int image_size;
    
    char name[128];
    double update_rate;

};

#define SERIAL_CAM_SIZE_160_120     0
#define SERIAL_CAM_SIZE_320_240     1
#define SERIAL_CAM_SIZE_640_480     2
void camera_data( unsigned char *buff, int len);

#endif
