/*
	Serial Camera Client 
	Version 11/24/2010-A
	(C) 2010 Jason Hunt nulluser@gmail.com

	This program is free software; you can redistribute it and/or
    	modify it under the terms of the GNU General Public License
    	as published by the Free Software Foundation; either version 2
    	of the License, or (at your option) any later version.

    	This program is distributed in the hope that it will be useful,
    	but WITHOUT ANY WARRANTY; without even the implied warranty of
    	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    	GNU General Public License for more details.

    	You should have received a copy of the GNU General Public License
    	along with this program; if not, write to the Free Software
    	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#include <windows.h>
#include <stdio.h>
#include "display.h"

#include "utility.h"
#include "time.h"



CRITICAL_SECTION debug_lock;

/* Add a byte to a buffer */
void append_byte(unsigned char *buffer, unsigned int &index, unsigned char data)
{
    buffer[index++] = data;
}
/* End of append_byte */



    static FILE *log_file;

/* Write formatted data to the debugging console */
void console(char *fmt, ... )
{
    static HANDLE h_console = INVALID_HANDLE_VALUE;

    if (h_console == INVALID_HANDLE_VALUE)
    {
        AllocConsole();
        h_console =  GetStdHandle(STD_OUTPUT_HANDLE); 
     }
   
    const unsigned int max = 1024;

    va_list args;
    char text[max];

    va_start(args, fmt);
    vsnprintf(text, max, fmt, args);
    DWORD out = 0;

    WriteConsole(h_console, text, strlen(text), &out, NULL);

    va_end(args);    
    
    log("%s", text);
 
}
/* End of write_console */











/* Write formatted data to the debugging console */
void log(char *fmt, ... )
{
    static bool log_init = false;

    if (!log_init)
    {
        log_file = fopen("log.txt", "wt");
        
        log_init = true;
     }

    static double start_time = get_time();


    const unsigned int max = 30000;

    va_list args;
    char text[max];

    fprintf(log_file, "[%4.4f] ",  get_time() - start_time);



    va_start(args, fmt);
    vsnprintf(text, max, fmt, args);
    fprintf(log_file, "%s", text);

    va_end(args);    
 
    fprintf(log_file, "\n", text);
    
    fflush(log_file);
    
}


void log_stop( void )
{
  if(log_file !=NULL)
    fclose(log_file);
}


    


void show_buffer(char *header, unsigned char *data, int len, bool display)
{
    char item[5];
     
    unsigned int max = len * 5 + 100;
                

    char *buff = (char *) malloc(max);
                                           
    snprintf(buff, max, "%s: (%d) ", header , len);
    
    for (int i = 0; i < len; i++)
    {
        sprintf(item, "%02x ", data[i]);
        strcat(buff, item);
    }


    if (display)
        add_line("%s", buff);
    else
        log("%s", buff);
  
    free(buff);

}    

    
unsigned int get_checksum(unsigned char *buff, unsigned int len)
{
	unsigned char ck = 0;
	
	while(len)
	{
		ck += buff[--len];
	}

	return(ck);
}

    
    
    
    
    
    
    
    
    
    
